<template>
  <v-container>
    <v-row justify="center">
      <v-col xs="12" md="6">
        <v-row justify="center">
          <v-col xs="12">
            <h2 class="mt-2 mb-4">My Account</h2>
          </v-col>
        </v-row>

        <v-row v-if="editAccount" justify="center">
          <v-col xs="12">
            <EditAccount :setEditAccount="() => editAccount=false"/>
          </v-col>
        </v-row>

        <v-row v-if="!editAccount" justify="center">
          <v-col cols="12">
            <span>{{ user.firstName }} {{ user.lastName }}</span>
            <v-divider class=""></v-divider>
          </v-col>
          <v-col cols="12">
            <v-row>
              <v-col xs="12">
                <h5><b>Email:</b> {{ user.email }}</h5>
                <h5><b>Phone:</b> {{ user.phone }}</h5>
                <h5><b>Nickname:</b> {{ user.nickName }}</h5>
                <h5><b>Location:</b> {{ user.location }}</h5>
              </v-col>
              <v-col xs="6"> </v-col>
              <v-col cols="12">
                <v-btn
                  rounded
                  small
                  color="primary"
                  @click="() => (editAccount = true)"
                  >Edit account</v-btn
                >
              </v-col>
            </v-row>
          </v-col>
        </v-row>

        <v-row justify="center">
          <v-col xs="12" md="12">
            <h5 class="body-1 mb-8">Payments and credits</h5>
            <h6 v-if="user.card" class="body-2 mb-2">
              <b>Your saved card:</b>
              {{
                user.card
                  ? `xxxx-xxxx-xxxx-${user.card.last4}`
                  : 'No card on file'
              }}
            </h6>
            <v-row v-for="(user, index) in user.paymentMetheods" :key="index">
              <v-col cols="12" xs="12" md="12" lg="12">
                <v-icon class="mr-3">mdi-credit-card</v-icon>
                <span
                  >You current card for billing is a {{ user.brand }} ending
                  {{ user.last4 }}</span
                >
              </v-col>
            </v-row>
            <v-btn
              v-if="!editPayment"
              rounded
              small
              color="primary"
              @click="() => (editPayment = true)"
              >Add new payment card</v-btn
            >
          </v-col>
          <v-col v-if="editPayment" xs="12" md="12">
            <span>Add a new card</span>
            <AddNewPaymentCard :hasCard="user.card !== undefined"/>
          </v-col>
        </v-row>
      </v-col>
    </v-row>
  </v-container>
</template>

<script>
import EventBus from '@/event-bus'
import { mapState } from 'vuex'
import AddNewPaymentCard from './AddNewPaymentCard'
import EditAccount from './EditAccount'

export default {
  name: 'ClientAccount',
  components: {
    AddNewPaymentCard,
    EditAccount
  },
  data() {
    return {
      showSuccess: false,
      alert: true,
      editPayment: false,
      editAccount: false
    }
  },
  computed: {
    ...mapState('authentication', ['user'])
  },
  created() {
    EventBus.$on('cancel-payment', () => {
      this.editPayment = false
    })
  },
  methods: {
    setEditAccount() {
      this.editAccount = false
    }
  }
}
</script>
